// Copyright 2008 Brian Caine

// This file is part of Potpourri.

// Potpourri is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Potpourri is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTIBILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Potpourri. If not, see <http://www.gnu.org/licenses/>.


// NOTES:
// This is some code that parses some xml using xml++
// It's autogenerated and poorly so

#include "../../include/core/parsegame.h"
#include "../../dtd/game.h"

#include <stdexcept>
#include <iostream>

using namespace XMLParser;
using namespace parsegame;

std::string XMLParser::parsegame::parsetitle(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseversion(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseauthor(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseabout(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseicon(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

meta XMLParser::parsegame::parsemeta(xmlpp::Node* node)
{
  meta results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "title")
        {
          std::string temp = parsetitle(*iter);
          results.m_title = temp;
        }

      if ((*iter)->get_name() == "version")
        {
          std::string temp = parseversion(*iter);
          results.m_version = temp;
        }

      if ((*iter)->get_name() == "author")
        {
          std::string temp = parseauthor(*iter);
          results.m_author.push_back(temp);
        }

      if ((*iter)->get_name() == "about")
        {
          std::string temp = parseabout(*iter);
          results.m_about = temp;
        }

      if ((*iter)->get_name() == "icon")
        {
          std::string temp = parseicon(*iter);
          results.m_icon = temp;
        }

    }

  return results;
}

int XMLParser::parsegame::parsewidth(xmlpp::Node* node)
{
  int results;

  results = fromString<int>(getContents(node));

  return results;
}

int XMLParser::parsegame::parseheight(xmlpp::Node* node)
{
  int results;

  results = fromString<int>(getContents(node));

  return results;
}

graphics XMLParser::parsegame::parsegraphics(xmlpp::Node* node)
{
  graphics results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "width")
        {
          int temp = parsewidth(*iter);
          results.m_width = temp;
        }

      if ((*iter)->get_name() == "height")
        {
          int temp = parseheight(*iter);
          results.m_height = temp;
        }

    }

  return results;
}

bool XMLParser::parsegame::parsenet(xmlpp::Node*){ return true; }

namespace XMLParser
{
namespace parsegame
{
presentation parsepresentation(xmlpp::Node* node)
{
  presentation results;
  results.m_net = false;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {
      xmlpp::Node* cur_node = *iter;
      if ((*iter)->get_name() == "name")
        {
          std::string temp = parsename(*iter);
          results.m_name = temp;
        }

      if ((*iter)->get_name() == "screen")
        {
          graphics temp = parsegraphics(*iter);
          results.m_graphics = temp;
        }

      if ((*iter)->get_name() == "net")
        {
          bool temp = parsenet(*iter);
          results.m_net = temp;
        }

    }

  return results;
}
}
}

std::string XMLParser::parsegame::parsedefault(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

event XMLParser::parsegame::parseevent(xmlpp::Node* node)
{
  event results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "name")
        {
          std::string temp = parsename(*iter);
          results.m_name = temp;
        }

      if ((*iter)->get_name() == "default")
        {
          std::string temp = parsedefault(*iter);
          results.m_default = temp;
        }

    }

  return results;
}

controls XMLParser::parsegame::parsecontrols(xmlpp::Node* node)
{
  controls results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "event")
        {
          event temp = parseevent(*iter);
          results.m_event.push_back(temp);
        }

    }

  return results;
}

std::string XMLParser::parsegame::parsegraphicsplugin(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseinput(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseaudioplugin(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parsescript(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parseextra(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

plugins XMLParser::parsegame::parseplugins(xmlpp::Node* node)
{
  plugins results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "graphics_p")
        {
          std::string temp = parsegraphicsplugin(*iter);
          results.m_graphics = temp;
        }

      if ((*iter)->get_name() == "input")
        {
          std::string temp = parseinput(*iter);
          results.m_input = temp;
        }

      if ((*iter)->get_name() == "audio_p")
        {
          std::string temp = parseaudioplugin(*iter);
          results.m_audio = temp;
        }

      if ((*iter)->get_name() == "script")
        {
          std::string temp = parsescript(*iter);
          results.m_script = temp;
        }

      if ((*iter)->get_name() == "extra")
        {
          std::string temp = parseextra(*iter);
          results.m_extra.push_back(temp);
        }

    }

  return results;
}

std::string XMLParser::parsegame::parseplugin(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

dgraphics XMLParser::parsegame::parsedgraphics(xmlpp::Node* node)
{
  dgraphics results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "name")
        {
          std::string temp = parsename(*iter);
          results.m_name = temp;
        }

      if ((*iter)->get_name() == "plugin")
        {
          std::string temp = parseplugin(*iter);
          results.m_plugin = temp;
        }

      if ((*iter)->get_name() == "filename")
        {
          std::string temp = parsefilename(*iter);
          results.m_filename = temp;
        }

    }

  return results;
}

std::string XMLParser::parsegame::parsename(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parsefilename(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

audio XMLParser::parsegame::parseaudio(xmlpp::Node* node)
{
  audio results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "name")
        {
          std::string temp = parsename(*iter);
          results.m_name = temp;
        }

      if ((*iter)->get_name() == "filename")
        {
          std::string temp = parsefilename(*iter);
          results.m_filename = temp;
        }

    }

  return results;
}

media XMLParser::parsegame::parsemedia(xmlpp::Node* node)
{
  media results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {

      if ((*iter)->get_name() == "graphics")
        {
          dgraphics temp = parsedgraphics(*iter);
          results.m_graphics.push_back(temp);
        }

      if ((*iter)->get_name() == "audio")
        {
          audio temp = parseaudio(*iter);
          results.m_audio.push_back(temp);
        }

    }

  return results;
}

std::string XMLParser::parsegame::parseactor(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

std::string XMLParser::parsegame::parselevel(xmlpp::Node* node)
{
  std::string results;

  results = getContents(node);

  return results;
}

game XMLParser::parsegame::parsegameFromBuffer(std::string buffer)
{
  game results;

  xmlpp::Node* base = 0;

  try
    {
      xmlpp::DomParser parser;
      parser.set_substitute_entities();

      parser.parse_memory(buffer);

      if (parser)
        base = parser.get_document()->get_root_node();
      else
        throw std::runtime_error("some weird error");

      if (!validXML(game_str, "game", &parser))
        throw std::runtime_error("invalid");

      results = XMLParser::parsegame::parsegame(base);
    }

  catch (const std::exception& e)
    {
      throw std::runtime_error(
        std::string("XMLParser::parsegame::parsegameFromBuffer(): "
                    "xmlpp error: ") + e.what());
    }

  return results;
}

controls XMLParser::parsegame::parsecontrolsFromBuffer(std::string buffer)
{
  controls results;

  xmlpp::Node* base = 0;

  try
    {
      xmlpp::DomParser parser;
      parser.set_substitute_entities();

      parser.parse_memory(buffer);

      if (parser)
        base = parser.get_document()->get_root_node();
      else
        throw std::runtime_error("some weird error");

      results = XMLParser::parsegame::parsecontrols(base);
    }

  catch (const std::exception& e)
    {
      throw std::runtime_error(
        std::string("XMLParser::parsegame::parsecontrolsFromBuffer(): "
                    "xmlpp error: ") + e.what());
    }

  return results;
}

std::map<std::string, std::string>
XMLParser::parsegame::controlsTomap(controls ncontrols)
{
  std::map<std::string, std::string> results;
  int cur;

  for (cur = 0; cur < ncontrols.m_event.size(); cur++)
    results[ncontrols.m_event.at(cur).m_name] =
      ncontrols.m_event.at(cur).m_default;

  return results;
}

game XMLParser::parsegame::parsegame(xmlpp::Node* node)
{
  game results;

  xmlpp::Node::NodeList list = node->get_children();

  xmlpp::Node::NodeList::iterator iter;
  for (iter = list.begin(); iter != list.end(); iter++)
    {
      xmlpp::Node* cur_node = *iter;

      if ((*iter)->get_name() == "meta")
        {
          meta temp = parsemeta(*iter);
          results.m_meta = temp;
        }

      if ((*iter)->get_name() == "presentation")
        {
          presentation temp = parsepresentation(*iter);
          results.m_presentation.push_back(temp);
        }

      if ((*iter)->get_name() == "controls")
        {
          controls temp = parsecontrols(*iter);
          results.m_controls = temp;
        }

      if ((*iter)->get_name() == "plugins")
        {
          plugins temp = parseplugins(*iter);
          results.m_plugins = temp;
        }

      if ((*iter)->get_name() == "media")
        {
          media temp = parsemedia(*iter);
          results.m_media = temp;
        }

      if ((*iter)->get_name() == "actor")
        {
          std::string temp = parseactor(*iter);
          results.m_actor.push_back(temp);
        }

      if ((*iter)->get_name() == "level")
        {
          std::string temp = parselevel(*iter);
          results.m_level.push_back(temp);
        }

    }

  return results;
}
